;;==========================================================================
;;    " "
;;

.dseg
mmusic_DispSkipCnt:	.byte	1		; ޣ   
mmusic_SREG:		.byte	1		; SREG,     mmusic_E_UserInterface
mmusic_DispMode:	.byte	1		;     :
		; D0 -   ( ), D1 -    128-  ( )
mmusic_FrgSkipCount:	.byte	2		;   .  > 0 -    
mmusic_SeekMode:	.byte	1		;      FileOffset    FileOffset
mmusic_FileOffset:	.byte	3		;    ,  

.eseg
nv_mmusic_DirEntLabel:	.byte	MaxDirDeep*3	;  
nv_mmusic_FileOffset:	.byte	3		;   ,   

.cseg
;
;   " "
;
mmusic_Enter:
 sbrs	r16, 0
 rjmp	mmusic_E_GoTo_ModeMenu	;          

 clr	r16
 sts	mmusic_SeekMode, r16

;
;    
;
mmusic_E_StartPlay:
 clr	r16			;         #0
 sts	mmusic_DispMode, r16
 sts	mmusic_FrgSkipCount+0, r16
 sts	mmusic_FrgSkipCount+1, r16

 rcall	mmusic_PathPrint	;      

 call	file_Idnt		;    mp3-
 brcc	mmusic_E_NextFile	;   -   

 call	file_OpenAndHold	;  .    - ,   ,
 call	lcd_PrintC		;   ģ      mp3-
.db	"Open: ", 1
 brcc	mmusic_E_NextFile

 call	vlsi_Open		; NB:    VLSI  -    ,   

 rcall	mmusic_SyncOffset	;      FileOffset    

 ldi	r16, 1              
 sts	mmusic_DispSkipCnt, r16

mmusic_E_SP_1:
 rcall	mmusic_IsBlockDecode	; ,         ?
 brpl	mmusic_E_SP_6

 ldi	ZL, low(IDEBuf0)	;   
 ldi	ZH, high(IDEBuf0)
 call	file_Read
 brcs	mmusic_E_SP_2		;    - 
 call	lcd_PrintC		;  - ,   ,    
.db	"Read: ", 1
 rjmp	mmusic_E_NextFile
mmusic_E_SP_2:

 ldi	ZL, low(IDEBuf0)	;    VLSI
 ldi	ZH, high(IDEBuf0)
 call	vlsi_SendBuf
mmusic_E_SP_6:

 rcall	mmusic_E_KbAnalyse	;   
 breq	mmusic_E_StartPlay	;    
 brts	mmusic_E_GoTo_ModeMenu	;     
 brcs	mmusic_E_NextFile	;    

 lds	r16, kb_Keys		;       ...
 tst	r16
 brne	mmusic_E_SP_5		; ...    ...
 lds	r16, mmusic_DispSkipCnt
 dec	r16
 brne	mmusic_E_SP_3
 ldi	r16, 30			; ...   30 
mmusic_E_SP_3:
 sts	mmusic_DispSkipCnt, r16
 brne	mmusic_E_SP_4		;     "dec"
mmusic_E_SP_5:
 rcall	mmusic_E_RefreshDisplay
mmusic_E_SP_4:

 rcall	mmusic_F_Step		;    
 brcs	mmusic_E_SP_1		; C == 0     ,    
 				;    
 call	vlsi_Close		;    ()

mmusic_E_NextFile:		;     
 call	file_Next
 call	lcd_PrintC
.db	"Next: ", 1
 brcc	mmusic_E_GoTo_ModeMenu
 rjmp	mmusic_E_StartPlay

mmusic_E_GoTo_ModeMenu:
 ldi	r16, m_ModeMenu		;        
 sec
 ret

;
;  
;
mmusic_E_RefreshDisplay:
 ldi	r16, 0x00
 call	lcd_SetAttr

 call	vlsi_GetState

 clr	r17			; 
 call	lcd_GoToLine

 call	lcd_Print
.db	"   ", 1

 lds	dd16uL, vlsi_V_L
 com	dd16uL
 call	DecByteOut
 ldi	r25, '/'
 call	lcd_CharOut
 lds	dd16uL, vlsi_V_R
 com	dd16uL
 call	DecByteOut

 call	lcd_Print
.db	"   ", 1

 lds	r16, mmusic_DispMode
 sbrc	r16, 1
 rjmp	mmusic_E_RD_Frg

mmusic_E_RD_Sec:
 lds	dd16uL, vlsi_Time+0	; 
 lds	dd16uH, vlsi_Time+1

 ldi	r16, 60
 mov	dv16uL, r16
 clr	dv16uH    
 call	div16u			; dres16uL = time / 60, drem16uL = time mod 60

 push	drem16uL
 push	drem16uH

 call	DecWordOut

 ldi	r25, ':'
 call	lcd_CharOut

 pop	dd16uH
 pop	dd16uL

 call	DecWordOut

; call	lcd_Print
;.db	" :", 1

 jmp	lcd_ClrEol		; FIN

mmusic_E_RD_Frg:
 lds	dd16uL, mmusic_FileOffset+1
 lds	dd16uH, mmusic_FileOffset+2
 call	DecWordOut		;  (256 )
 
; call	lcd_Print
;.db	" ", 1

 jmp	lcd_ClrEol		; FIN

;
;  FileOffset    
;
mmusic_SyncOffset:
 clr	r17
 lds	r16, mmusic_SeekMode	;     -  FileOffset,
 tst	r16			;  -   FileOffset (   )
 breq	mmusic_SO_zero

 sts	mmusic_SeekMode, r17	;      ӣ   
 rcall	mmusic_E_kr_FrgMode	; VLSI           

;  mmusic_FileOffset 

 lds	ZL,  mmusic_FileOffset+0
 lds	ZH,  mmusic_FileOffset+1
 lds	r16, mmusic_FileOffset+2

mmusic_SO_1:
 mov	r17, ZL
 or	r17, ZH
 or	r17, r16
 breq	mmusic_SO_ret

 push	ZL
 push	ZH
 push	r16
 call	file_Step
 pop	r16
 pop	ZH
 pop	ZL
 brcc	mmusic_SO_ret

 sbiw	ZL, 1
 sbci	r16, 0
 rjmp	mmusic_SO_1

;  mmusic_FileOffset

mmusic_SO_zero:
 sts	mmusic_FileOffset+0, r17
 sts	mmusic_FileOffset+1, r17
 sts	mmusic_FileOffset+2, r17

mmusic_SO_ret:
 ret

;
;  ޣ   
;   ޣ 
;
mmusic_F_Step:
 lds	ZL, mmusic_FileOffset+0
 lds	ZH, mmusic_FileOffset+1
 lds	r16, mmusic_FileOffset+2
 clr	r17
 adiw	ZL, 1
 adc	r16, r17
 sts	mmusic_FileOffset+0, ZL
 sts	mmusic_FileOffset+1, ZH
 sts	mmusic_FileOffset+2, r16
 jmp	file_Step

;
;  ޣ    ,
;        ?
; N = 0 -     
;
mmusic_IsBlockDecode:
 lds	ZL, mmusic_FrgSkipCount+0
 lds	ZH, mmusic_FrgSkipCount+1
 sbiw	Z, 1
 brmi	mmusic_IBD_ret
 sts	mmusic_FrgSkipCount+0, ZL
 sts	mmusic_FrgSkipCount+1, ZH
mmusic_IBD_ret:
 ret

;
;  
;
;   Z  T  :
; Z = 1 -    (  Σ)
; Z = 0, T = 1 -   ModeMenu
; Z = 0, T = 0, C = 1 -    
; Z = 0, T = 0, C = 0 -  
;
mmusic_E_KbAnalyse:
 lds	r16, mmusic_DispMode
 sbrc	r16, 0
 rjmp	mmusic_E_KbToneAnalyse

;  F-:		 :
;	NextF	NextD		0	1
;	PrevF	PrevD		2	3
;	Vol+	[F] Info	4	5
;	Vol-	Pause		6	7
;   F:
;	?	pc_Menu
;	Tone	MainMenu
;	Repeat	[F] -
;	Pan-	Pan+
; :	0 + 2 -  
;		4 + 6 -  

 in	r16, SREG
 cbr	r16, 0x43		;  T, Z, C
 sts	mmusic_SREG, r16

 call	ur_KeybRoute
.db	Key0mask, 0x40
.dw	mmusic_E_kr_NextFile

.db	Key2mask, 0x40
.dw	mmusic_E_kr_PrevFile

.db	Key1mask, 0x40
.dw	mmusic_E_kr_NextDir

.db	Key3mask, 0x40
.dw	mmusic_E_kr_PrevDir

.db	Key4mask, 0x00
.dw	mmusic_E_kr_IncVol

.db	Key6mask, 0x00
.dw	mmusic_E_kr_DecVol

.db	Key7mask, 0x40
.dw	mmusic_E_kr_Pause

.db	Key5mask, 0x00
.dw	mmusic_E_kr_ChDisplayMode


.db	Key0mask | Key2mask, 0x40
.dw	mmusic_E_kr_LoadLabel

.db	Key4mask | Key6mask, 0x40
.dw	mmusic_E_kr_SaveLabel


.db	Key1mask | Key5mask, 0x40
.dw	mmusic_E_kr_pc_Menu

.db	Key2mask | Key5mask, 0x40
.dw	mmusic_E_kr_ToneChangeEn

.db	Key3mask | Key5mask, 0x40
.dw	mmusic_E_kr_MainMenu

.db	Key4mask | Key5mask, 0x40
.dw	mmusic_E_kr_Repeat

.db	Key0mask | Key5mask, 0x40
.dw	mmusic_E_kr_ffwd

.db	Key4mask | Key7mask, 0x00
.dw	mmusic_E_kr_FrgMode

.db	Key6mask | Key5mask, 0x00
.dw	mmusic_E_kr_DecPan

.db	Key7mask | Key5mask, 0x80
.dw	mmusic_E_kr_IncPan

 lds	r16, mmusic_SREG	;      
 out	SREG, r16
 ret

;        
;  

mmusic_E_KbToneAnalyse:
 call	ur_KeybRoute
.db	Key5mask, 0x00
.dw	mmusic_Tone_ST_AmpDec

.db	Key3mask, 0x00
.dw	mmusic_Tone_ST_AmpInc

.db	Key0mask, 0x00
.dw	mmusic_Tone_ST_FrqDec

.db	Key1mask, 0x00
.dw	mmusic_Tone_ST_FrqInc

.db	Key4mask, 0x00
.dw	mmusic_Tone_SB_AmpDec

.db	Key2mask, 0x00
.dw	mmusic_Tone_SB_AmpInc

.db	Key6mask, 0x00
.dw	mmusic_Tone_SB_FrqDec

.db	Key7mask, 0x00
.dw	mmusic_Tone_SB_FrqInc

.db	Key3mask | Key4mask, 0x40
.dw	mmusic_Tone_DiffCh

.db	Key2mask | Key5mask, 0xC0
.dw	mmusic_E_kr_ToneChangeDi

 clc
 clz
 clt
 ret

;
;     
;
mmusic_E_kr_NextFile:		;   
 lds	r16, mmusic_SREG
 sbr	r16, 0x01		; C = 1
 sts	mmusic_SREG, r16
 ret

mmusic_E_kr_PrevFile:
 call	file_Prev
 call	lcd_PrintC
.db	"Prev: ", 1
 brcc	mmusic_E_kr_NextFile	;   - -      
 call	file_Idnt
 brcc	mmusic_E_kr_PrevFile

mmusic_E_kr_Repeat:
mmusic_E_kr_Send_REOPENFILE:
 lds	r16, mmusic_SREG
 sbr	r16, 0x02		; Z = 1
 sts	mmusic_SREG, r16
 ret

mmusic_E_kr_NextDir:
 rcall	pc_NextDir
 rjmp	mmusic_E_kr_Send_REOPENFILE

mmusic_E_kr_PrevDir:
 rcall	pc_PrevDir
 rjmp	mmusic_E_kr_Send_REOPENFILE

mmusic_E_kr_IncVol:
 ldi	r16, -1
 clr	r17
 jmp	vlsi_ChVol

mmusic_E_kr_DecVol:
 ldi	r16, 1
 clr	r17
 jmp	vlsi_ChVol

mmusic_E_kr_Pause:
 clc
 call	lcd_PrintC
.db	"- PAUSE * ", 1
 ret

mmusic_E_kr_ffwd:
 ldi	r16, 3			; ~800  = ~400  = ~10    320   ~100  - 32 
 sts	mmusic_FrgSkipCount+1, r16

mmusic_E_kr_FrgMode:
 lds	r16, mmusic_DispMode	;         
 sbr	r16, 0x02
 sts	mmusic_DispMode, r16
 ret

mmusic_E_kr_ToneChangeEn:
 lds	r16, mmusic_DispMode
 sbr	r16, 0x01
 sts	mmusic_DispMode, r16
 rjmp	mmusic_Tone_Draw

mmusic_E_kr_ToneChangeDi:
 lds	r16, mmusic_DispMode
 cbr	r16, 0x01
 sts	mmusic_DispMode, r16
 jmp	lcd_ClrScr

mmusic_E_kr_MainMenu:
 lds	r16, mmusic_SREG
 sbr	r16, 0x40		; T = 1
 sts	mmusic_SREG, r16
 ret

mmusic_E_kr_DecPan:
 clr	r16    
 ldi	r17, -1
 jmp	vlsi_ChVol

mmusic_E_kr_IncPan:
 clr	r16    
 ldi	r17, 1 
 jmp	vlsi_ChVol

mmusic_E_kr_pc_Menu:
 rcall	pc_Menu
 rjmp	mmusic_E_kr_Send_REOPENFILE

mmusic_E_kr_SaveLabel:
 call	f_IO
.db	f_OWrite, MaxDirDeep*3
.dw	nv_mmusic_DirEntLabel
.dw	CurrentDirEnt

 call	f_IO
.db	f_OWrite, 3
.dw	nv_mmusic_FileOffset
.dw	mmusic_FileOffset

 clc
 call	lcd_PrintC
.db	"  !", 1
 ret

mmusic_E_kr_LoadLabel:
 call	f_IO
.db	f_ORead, MaxDirDeep*3
.dw	nv_mmusic_DirEntLabel
.dw	CurrentDirEnt

 call	f_IO
.db	f_ORead, 3
.dw	nv_mmusic_FileOffset
.dw	mmusic_FileOffset

 ser	r16
 sts	mmusic_SeekMode, r16

 rjmp	mmusic_E_kr_Send_REOPENFILE

;
;    :
;  1, I:  
;  2, I:  
;  3, N:   ()
;  4, N:   ()
;  5, N:   ()
;
mmusic_PathPrint:

;;  

 ldi	r16, 0x80
 call	lcd_SetAttr


 ldi	r17, 1
 call	lcd_GoToLine

 rcall	pc_FindCurDeep
 push	r23
 ldi	r18, lcd_XPosMax
 cpi	r23, 1
 rcall	mmusic_SubPrintPath


 ldi	r17, 2
 call	lcd_GoToLine

 pop	r23
 inc	r23
 ldi	r18, lcd_XPosMax
 cpi	r23, 1
 rcall	mmusic_SubPrintPath

;;  

 ldi	r16, 0x00
 call	lcd_SetAttr
 ldi	r17, 3
 call	lcd_GoToLine

 clr	r23
 ldi	r18, lcd_XPosMax*3
 cls				; sign(>=)

mmusic_SubPrintPath:
 brlt	mmusic_SPP_1		; if sign(r1) < sign(r2)

 push	r18
 rcall	file_Name
; push	ZL
; push	ZH
; rcall	lcd_PrintC
;.db	"Get filename: ", 1	; 	  -  errno !
; pop	ZH
; pop	ZL
 pop	r18
 brcc	mmusic_SPP_1

mmusic_SPP_2:
 ld	r25, Z+
 tst	r25
 breq	mmusic_SPP_1
 call	lcd_CharOutNoLimit
 rjmp	mmusic_SPP_2

mmusic_SPP_1:
 jmp	lcd_ClrEolNoLimit

;
;    ( 2-6 )
;   /   
;
mmusic_E_kr_ChDisplayMode:
 jmp	vlsi_HDAT_print

;
;  
;
mmusic_Tone_DiffCh:
 lds	r16, vlsi_Mode
 ldi	r17, 1<<vlsi_SM_DIFF
 eor	r16, r17
 sts	vlsi_Mode, r16
 rjmp	mmusic_Tone_SB_2

mmusic_Tone_ST_AmpDec:
 lds	r16, vlsi_Ton+1
 subi	r16, 0x10
 rjmp	mmusic_Tone_ST_1

mmusic_Tone_ST_AmpInc:
 lds	r16, vlsi_Ton+1
 subi	r16, -0x10
 rjmp	mmusic_Tone_ST_1

mmusic_Tone_ST_FrqDec:
 lds	r16, vlsi_Ton+1
 swap	r16
 subi	r16, 0x10
 swap	r16
 rjmp	mmusic_Tone_ST_1

mmusic_Tone_ST_FrqInc:
 lds	r16, vlsi_Ton+1
 swap	r16
 subi	r16, -0x10
 swap	r16

mmusic_Tone_ST_1:
 sts	vlsi_Ton+1, r16
 rjmp	mmusic_Tone_SB_2

;

mmusic_Tone_SB_AmpDec:
 lds	r16, vlsi_Ton+0
 subi	r16, 0x10
 rjmp	mmusic_Tone_SB_1

mmusic_Tone_SB_AmpInc:
 lds	r16, vlsi_Ton+0
 subi	r16, -0x10
 rjmp	mmusic_Tone_SB_1

mmusic_Tone_SB_FrqDec:
 lds	r16, vlsi_Ton+0
 swap	r16
 subi	r16, 0x10
 swap	r16
 rjmp	mmusic_Tone_SB_1

mmusic_Tone_SB_FrqInc:
 lds	r16, vlsi_Ton+0
 swap	r16
 subi	r16, -0x10
 swap	r16

mmusic_Tone_SB_1:
 sts	vlsi_Ton+0, r16

mmusic_Tone_SB_2:
 ldi	r16, 1
 sts	vlsi_Dirt, r16

 rcall	mmusic_Tone_Draw
 jmp	vlsi_SetTones

;    

mmusic_Tone_Draw:
 ldi	r17, 1
 call	lcd_GoToLine

 ldi	r16, 0x80
 call	lcd_SetAttr
 
 call	lcd_Print
.db	" ", 1

 lds	r16, vlsi_Mode
 andi	r16, 1<<vlsi_SM_DIFF
 breq	mmusic_Tone_Draw_1
 call	lcd_Print
.db	"(. .)", 1
mmusic_Tone_Draw_1:

 call	lcd_ClrEol

 clr	r16
 call	lcd_SetAttr

;

 ldi	r17, 2
 call	lcd_GoToLine
 
 call	lcd_Print
.db	" :", 1

 call	lcd_ClrEol

;

 ldi	r17, 3
 call	lcd_GoToLine

 call	lcd_Print
.db	"  ", 1


 lds	r16, vlsi_Ton+1
 swap	r16
 andi	r16, 0x0F

 sbrs	r16, 3
 rjmp	mmusic_Tone_Draw_2
 push	r16

 ldi	r25, '-'
 call	lcd_CharOut

 pop	r16
 cpi	r16, 8
 breq	mmusic_Tone_Draw_2
 neg	r16
 andi	r16, 0x0F

mmusic_Tone_Draw_2:

 mov	mc16uL, r16
 clr	mc16uH

 ldi	r16, 15
 mov	mp16uL, r16
 clr	mp16uH

 call	mpy16u

 mov	dd16uL, m16u0
 call	DecByteOut

 call	lcd_Print
.db	"/10 dB, ", 1


 lds	r16, vlsi_Ton+1
 andi	r16, 0x0F
 mov	dd16uL, r16
 call	DecByteOut

 call	lcd_Print
.db	" KHz", 1

 call	lcd_ClrEol

;

 ldi	r17, 4
 call	lcd_GoToLine
 
 call	lcd_Print
.db	" :", 1

 call	lcd_ClrEol

;

 ldi	r17, 5
 call	lcd_GoToLine

 call	lcd_Print
.db	"   ", 1


 lds	r16, vlsi_Ton+0
 swap	r16
 andi	r16, 0x0F
 mov	dd16uL, r16
 call	DecByteOut

 call	lcd_Print
.db	"0/10 dB, ", 1

 lds	r16, vlsi_Ton+0
 andi	r16, 0x0F
 mov	dd16uL, r16
 call	DecByteOut

 call	lcd_Print
.db	"0 Hz", 1

 jmp	lcd_ClrEol
